The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::DelayL Class Reference

STK linear interpolating delay line class. More...

`#include <DelayL.h>`

Inheritance diagram for stk::DelayL:

## Public Member Functions
| DelayL (StkFloat delay=0.0, unsigned long maxDelay=4095)
| Default constructor creates a delay-line with maximum length of 4095 samples and zero delay.
| ~DelayL ()
| Class destructor.
unsigned long | getMaximumDelay (void)
| Get the maximum delay-line length.
void | setMaximumDelay (unsigned long delay)
| Set the maximum delay-line length.
void | setDelay (StkFloat delay)
| Set the delay-line length.
StkFloat | getDelay (void) const
| Return the current delay-line length.
StkFloat | tapOut (unsigned long tapDelay)
| Return the value at tapDelay samples from the delay-line input.
void | tapIn (StkFloat value, unsigned long tapDelay)
| Set the value at tapDelay samples from the delay-line input.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | nextOut (void)
| Return the value which will be output by the next call to tick().
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.
Public Member Functions inherited from stk::Filter
| Filter (void)
| Class constructor.
unsigned int | channelsIn (void) const
| Return the number of input channels for the class.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
virtual void | clear (void)
| Clears all internal states of the filter.
void | setGain (StkFloat gain)
| Set the filter gain.
StkFloat | getGain (void) const
| Return the current filter gain.
StkFloat | phaseDelay (StkFloat frequency)
| Return the filter phase delay at the specified frequency.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK linear interpolating delay line class.

This class implements a fractional-length digital delay-line using first-order linear interpolation. If the delay and maximum length are not specified during instantiation, a fixed maximum length of 4095 and a delay of zero is set.

Linear interpolation is an efficient technique for achieving fractional delay lengths, though it does introduce high-frequency signal attenuation to varying degrees depending on the fractional delay setting. The use of higher order Lagrange interpolators can typically improve (minimize) this attenuation characteristic.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ DelayL()

stk::DelayL::DelayL | ( | StkFloat | delay = 0.0,
|  | unsigned long | maxDelay = 4095 )

Default constructor creates a delay-line with maximum length of 4095 samples and zero delay.

An StkError will be thrown if the delay parameter is less than zero, the maximum delay parameter is less than one, or the delay parameter is greater than the maxDelay value.

## Member Function Documentation

## ◆ setMaximumDelay()

void stk::DelayL::setMaximumDelay | ( | unsigned long | delay | ) |

Set the maximum delay-line length.

This method should generally only be used during initial setup of the delay line. If it is used between calls to the tick() function, without a call to clear(), a signal discontinuity will likely occur. If the current maximum length is greater than the new length, no memory allocation change is made.

## ◆ setDelay()

void stk::DelayL::setDelay | ( | StkFloat | delay | ) |
| inline

Set the delay-line length.

The valid range for delay is from 0 to the maximum delay-line length.

137{
138 if ( delay + 1 > inputs_.size() ) { // The value is too big.
139 oStream_ << "DelayL::setDelay: argument (" << delay << ") greater than maximum!";
140 handleError( StkError::WARNING ); return;
141 }
142
143 if (delay < 0 ) {
144 oStream_ << "DelayL::setDelay: argument (" << delay << ") less than zero!";
145 handleError( StkError::WARNING ); return;
146 }
147
148 StkFloat outPointer = inPoint_ - delay; // read chases write
149 delay_ = delay;
150
151 while ( outPointer < 0 )
152 outPointer += inputs_.size(); // modulo maximum length
153
154 outPoint_ = (long) outPointer; // integer part
155
156 alpha_ = outPointer - outPoint_; // fractional part
157 omAlpha_ = (StkFloat) 1.0 - alpha_;
158
159 if ( outPoint_ == inputs_.size() ) outPoint_ = 0;
160 doNextOut_ = true;
161}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tapOut()

StkFloat stk::DelayL::tapOut | ( | unsigned long | tapDelay | ) |

Return the value at tapDelay samples from the delay-line input.

The tap point is determined modulo the delay-line length and is relative to the last input value (i.e., a tapDelay of zero returns the last input value).

## ◆ nextOut()

StkFloat stk::DelayL::nextOut | ( | void |  | ) |
| inline

Return the value which will be output by the next call to tick().

This method is valid only for delay settings greater than zero!

121{
122 if ( doNextOut_ ) {
123 // First 1/2 of interpolation
124 nextOutput_ = inputs_[outPoint_] * omAlpha_;
125 // Second 1/2 of interpolation
126 if (outPoint_+1 < inputs_.size())
127 nextOutput_ += inputs_[outPoint_+1] * alpha_;
128 else
129 nextOutput_ += inputs_[0] * alpha_;
130 doNextOut_ = false;
131 }
132
133 return nextOutput_;
134}

## ◆ tick() [1/2]

StkFrames & stk::DelayL::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = 0 )
| inlinevirtual

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

182{
183#if defined(_STK_DEBUG_)
184 if ( channel >= frames.channels() ) {
185 oStream_ << "DelayL::tick(): channel and StkFrames arguments are incompatible!";
186 handleError( StkError::FUNCTION_ARGUMENT );
187 }
188#endif
189
190 StkFloat *samples = &frames[channel];
191 unsigned int hop = frames.channels();
192 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
193 inputs_[inPoint_++] = *samples * gain_;
194 if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
195 *samples = nextOut();
196 doNextOut_ = true;
197 if ( ++outPoint_ == inputs_.size() ) outPoint_ = 0;
198 }
199
200 lastFrame_[0] = *(samples-hop);
201 return frames;
202}
stk::DelayL::nextOut
StkFloat nextOut(void)
Return the value which will be output by the next call to tick().
Definition DelayL.h:120

## ◆ tick() [2/2]

StkFrames & stk::DelayL::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = 0,
|  | unsigned int | oChannel = 0 )
| inline

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

205{
206#if defined(_STK_DEBUG_)
207 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
208 oStream_ << "DelayL::tick(): channel and StkFrames arguments are incompatible!";
209 handleError( StkError::FUNCTION_ARGUMENT );
210 }
211#endif
212
213 StkFloat *iSamples = &iFrames[iChannel];
214 StkFloat *oSamples = &oFrames[oChannel];
215 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
216 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
217 inputs_[inPoint_++] = *iSamples * gain_;
218 if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
219 *oSamples = nextOut();
220 doNextOut_ = true;
221 if ( ++outPoint_ == inputs_.size() ) outPoint_ = 0;
222 }
223
224 lastFrame_[0] = *(oSamples-oHop);
225 return iFrames;
226}

The documentation for this class was generated from the following file:

- DelayL.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.